﻿using Benday.WpfCommandExceptionDemo.ViewModel;
using GalaSoft.MvvmLight.Command;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benday.WpfCommandExceptionDemo
{
    public class ExceptionHandlingRelayCommand : RelayCommand
    {
        public ExceptionHandlingRelayCommand(Action execute) : base(execute)
        {

        }

        public override void Execute(object parameter)
        {
            try
            {
                base.Execute(parameter);
            }
            catch (Exception ex)
            {
                HandleException(ex);
            }
        }

        private void HandleException(Exception ex)
        {
            new ViewModelLocator().Messages.ShowMessage(ex);
        }
    }
}
